#pragma once

#include "Vector.h"

#ifndef NULL
#define NULL 0
#endif

class Tree;

class Tree
{
	//Give access to all properties, used like a struct
	public:
	
	//Branch at this point
	float x, y, z;
	float thickness;
	
	//Children branching off -- may be just one child
	Tree **children;
	int numChildren;
	
	//Meta info
	Tree *axisRoot;		//Need to track axis (single direction shoot) to gather light/buds counts for priority model
	double light;		//gathered in pass 1
	int buds;			//gathered in pass 1
	double resource;	//distributed in pass 2
	bool bud;			//if true: keeps zero thickness (for Murphi calcs), and don't draw
	bool branch;		//indicates root node of a branch (axis).  Need to scanning through tree.
	Vec3 growth;		//direction of growth for a bud -- should always be normalized
	
	
	/**
	 * Constructor
	 */
	//Tree()
	//: x(0), y(0), z(0), thickness(0), numChildren(0), children(NULL)
	//{}
	
	Tree(float _x, float _y, float _z)
	: x(_x), y(_y), z(_z), thickness(0), numChildren(0), children(NULL),
	  axisRoot(NULL), light(0), buds(0), resource(0), bud(0), branch(0)
	{}

	
	/**
	 * Destructor
	 */
	Tree(){
		int i;
		for(i = 0; i < numChildren; i++)
			delete children[i];
		
		delete children;
	}
	
	void setNumChildren(int n);
	
};