#pragma once

#include "Tree.h"


//Settings
extern int thicknessN;		//good value for this is 3.  Trying 2 to make base wider
extern int thicknessInit;	//thickness at twig ends


class Treegen
{
	protected:
	Tree *root;		//points to the root of the generated tree
	int iterations;	//tracks how many iterations we've gone through
	
	
	public:
	
	/**
	 * Constructor
	 */
	Treegen()
	: root(NULL), iterations(0)
	{
		root = new Tree(0, 0, 0);	//start at origin
	}
	
	
	/**
	 * Destructor
	 */
	~Treegen() {
		//delete root;
	}
	
	Tree *getTree() { return root; }
	
	void calcThickness(int twigThickness);
	void clearThickness();
	
	virtual void generate() = 0;
	virtual void step() = 0;
	
	/* Display visually information about how the tree is being generated, e.g. voxel grid. */
	virtual void drawInfo() {}
};