#pragma once

#include "LightTree.h"

#define WIND_PIXELS_PER_VOXEL 10
extern int windBendsBranches;


class WindTree : public LightTree
{
	private:
	VoxelGrid *windVoxels;
	
	public:
	
	/**
	 * Constructor
	 */
	WindTree()
	: windVoxels(NULL)
	{
		//Make a voxel grid to use for wind
		windVoxels = new VoxelGrid(80,80,80);
		
		//Need to cast shadow for initial bud
		windVoxels->occludeRight(windVoxels->pixelsToVoxel(0, 0, 0, WIND_PIXELS_PER_VOXEL));
	}
	
	virtual void drawInfo();
	
	//Internal helper functions
	private:
	virtual void calcVectors();	//virtual to allow a sub-class to add in wind effects.
	
	double calcWind(Tree *bud);
	virtual void occlude(Tree *bud);
	
};